/* =================================
 * jQuery easy-opener v1.0
 *
 * TERMS OF USE - jQuery easy-opener
 *
 * Copyright © 2014 Spab Rice
 * All rights reserved.
 ================================= */

jQuery(document).ready(function () {
    "use strict";
    jQuery(".easy-opener").on("click", function () {
        var thisEl = jQuery(this);
        var windowWidth = jQuery(window).width();
        var windowHeight = jQuery(window).height();
        var maxWidth = Math.ceil(windowWidth * 0.6);
        var maxHeight = Math.ceil(windowHeight * 0.8);
        if (windowWidth < 760)maxWidth = 300;
        var type = jQuery(this).data("type");
        if (!type)type = "image";
        var direction = jQuery(this).data("direction");
        var gallery = jQuery(this).data("gallery");
       jQuery(".easy-opener-content").animate({opacity: 0},
            500, function () {
            });
        if (type == "video") {
            var videoWidth = jQuery(this).data("width");
            var videoHeight = jQuery(this).data("height");
            var theVideo = jQuery(this).attr("href");
            if (!videoWidth || !videoHeight) {
                alert("Please enter a data-width AND data-height");
                return false
            }
            createVideo(maxWidth, maxHeight, videoWidth, videoHeight, theVideo)
        } else if (type == "image") {
            var theImage = jQuery(this).attr("href");
            createImage(maxWidth, maxHeight, theImage)
        }
        if (gallery)createNextPrev(gallery, thisEl, direction);
        return false
    });
    jQuery(".easy-opener-close").on("click",
        function () {
            jQuery("#easy-opener-section").fadeOut(500, function () {
                jQuery(".easy-opener-content").animate({opacity: 0}, 50, function () {
                    //jQuery("#easy-opener-section").remove()
                })
                jQuery('.video-content').html('');
            });
            return false
        })
});
//function createOpener() {
//    jQuery("body").append('')
//}
function createVideo(maxW, maxH, elW, elH, vid) {
    maxProportion = maxW / maxH;
    elProportion = elW / elH;
    if (elProportion > maxProportion) {
        finalElW = maxW;
        finalElH = Math.ceil(maxW / elW * elH)
    } else {
        finalElH = maxH;
        finalElW = Math.ceil(maxH / elH * elW)
    }
    var marginLeft = Math.ceil(finalElW / 2);
    jQuery(".easy-opener-content").css({"width": finalElW + "px", "marginLeft": "-" + marginLeft + "px"});
    jQuery(".easy-opener-content .video-content").append('<iframe src="' + vid + '" width="' + elW + '" height="' + elH + '"></iframe>');
    jQuery("#easy-opener-section").fitVids();
    jQuery("#easy-opener-section").fadeIn(500, function () {
        var scrollTop = jQuery(document).scrollTop();
        var topMargin = scrollTop + Math.ceil((jQuery(window).height() - finalElH) / 2);
        jQuery(".easy-opener-content").css({"top": topMargin + "px"}).delay(1E3).animate({opacity: 1}, 600)
    })
}
function createImage(maxW, maxH, image) {
    maxProportion = maxW / maxH;
    jQuery(".easy-opener-content").css({"width": maxW + "px", "height": maxH + "px"});
    jQuery(".easy-opener-content").html('<a class="easy-opener-close" href="#"></a><img src="' + image + '" />');
    jQuery("#easy-opener-section").fadeIn(500, function () {
        jQuery(".easy-opener-content").css({
            "width": jQuery(".easy-opener-content img").width() + "px",
            "height": jQuery(".easy-opener-content img").height() + "px"
        });
        var scrollTop = jQuery(document).scrollTop();
        var topMargin =
            scrollTop + Math.ceil((jQuery(window).height() - maxH) / 2);
        var leftMargin = Math.ceil(jQuery(".easy-opener-content img").width() / 2);
        jQuery(".easy-opener-content").css({
            "top": topMargin + "px",
            "marginLeft": "-" + leftMargin + "px"
        }).delay(1E3).animate({opacity: 1}, 600)
    })
}
function createNextPrev(gal, el, dir) {
    var i = -1;
    jQuery(".easy-opener[data-gallery='" + gal + "']").each(function (index) {
        if (!jQuery(this).attr("data-galsort") || !dir)jQuery(this).attr("data-galsort", index);
        i++
    });
    var thisElID = jQuery(el).attr("data-galsort");
    if (dir)thisElID = jQuery(el).attr("data-pseudosort");
    var nextElID = parseInt(thisElID) + 1;
    var prevElID = parseInt(thisElID) - 1;
    if (prevElID < 0)prevElID = i;
    if (nextElID > i)nextElID = 0;
    var typeNext = jQuery(".easy-opener[data-galsort='" + nextElID + "']").data("type");
    if (typeNext ==
        "video") {
        var widthNext = jQuery(".easy-opener[data-galsort='" + nextElID + "']").data("width");
        var heightNext = jQuery(".easy-opener[data-galsort='" + nextElID + "']").data("height");
        var theVideoNext = jQuery(".easy-opener[data-galsort='" + nextElID + "']").attr("href");
        var galSortPeudoNext = jQuery(".easy-opener[data-galsort='" + nextElID + "']").data("galsort");
        var infosNext = 'href="' + theVideoNext + '" data-pseudosort="' + galSortPeudoNext + '" data-type="video" data-width="' + widthNext + '" data-height="' + heightNext + '" data-gallery="' +
            gal + '"'
    } else if (typeNext == "image" || !typeNext) {
        var theImageNext = jQuery(".easy-opener[data-galsort='" + nextElID + "']").attr("href");
        var galSortPeudoNext = jQuery(".easy-opener[data-galsort='" + nextElID + "']").data("galsort");
        var infosNext = 'href="' + theImageNext + '" data-pseudosort="' + galSortPeudoNext + '" data-type="image" data-gallery="' + gal + '"'
    }
    var typePrev = jQuery(".easy-opener[data-galsort='" + prevElID + "']").data("type");
    if (typePrev == "video") {
        var widthPrev = jQuery(".easy-opener[data-galsort='" + prevElID + "']").data("width");
        var heightPrev = jQuery(".easy-opener[data-galsort='" + prevElID + "']").data("height");
        var theVideoPrev = jQuery(".easy-opener[data-galsort='" + prevElID + "']").attr("href");
        var galSortPeudoPrev = jQuery(".easy-opener[data-galsort='" + prevElID + "']").data("galsort");
        var infosPrev = 'href="' + theVideoPrev + '" data-pseudosort="' + galSortPeudoPrev + '" data-type="video" data-width="' + widthPrev + '" data-height="' + heightPrev + '" data-gallery="' + gal + '"'
    } else if (typePrev == "image" || !typePrev) {
        var theImagePrev = jQuery(".easy-opener[data-galsort='" +
        prevElID + "']").attr("href");
        var galSortPeudoPrev = jQuery(".easy-opener[data-galsort='" + prevElID + "']").data("galsort");
        var infosPrev = 'href="' + theImagePrev + '" data-pseudosort="' + galSortPeudoPrev + '" data-type="image" data-gallery="' + gal + '"'
    }
    jQuery(".easy-opener-content").prepend('<a class="easy-opener easy-opener-next" ' + infosNext + ' data-direction="next"></a>');
    jQuery(".easy-opener-content").prepend('<a class="easy-opener easy-opener-prev" ' + infosPrev + ' data-direction="prev"></a>')
};
